#ifndef AccountHistorieDaten_H
#define AccountHistorieDaten_H

#include <Array.h>
#include <Text.h>

using namespace Framework;

struct AHSpielSpielerDaten : public virtual ReferenceCounter
{
    Text *name;
    int punkte;
    Text *status;
    int farbe;

    // Konstruktor
    AHSpielSpielerDaten();
    // Destruktor
    ~AHSpielSpielerDaten();
};

struct AHSpielTeamDaten : public virtual ReferenceCounter
{
    int id;
    Text *name;
    int sAnzahl;
    Text *status;
    int farbe;
    RCArray< AHSpielSpielerDaten > *spieler;

    // Konstruktor
    AHSpielTeamDaten();
    // Destruktor
    ~AHSpielTeamDaten();
};

struct AHSpielDaten : public virtual ReferenceCounter
{
    int id;
    int karteId;
    Text *spiel;
    Text *karte;
    Text *datum;
    Text *status;
    Text *dauer;
    Text *spielStatus;
    Text *gewinner;
    int sAnzahl;
    RCArray< AHSpielTeamDaten > *teams;

    // Konstruktor
    AHSpielDaten();
    // Destruktor
    ~AHSpielDaten();
};

struct AHDaten : public virtual ReferenceCounter
{
    RCArray< AHSpielDaten > *spiele;

    // Konstruktor
    AHDaten();
    // Destruktor
    ~AHDaten();
};

struct SpielerTeamStruktur : public virtual ReferenceCounter
{
    SpielerTeamStruktur();
    ~SpielerTeamStruktur();
    int spielerAnzahl;
    int teamAnzahl;
    Array< int > *spielerFarbe;
    Array< int > *teamFarbe;
    RCArray< Text > *teamName;
    Array< int > *teamSize;
};

#endif